<?php
//
// +---------------------------------------------------------------------------+
// | linkreferer Plugin 1.0 for Geeklog - The Ultimate Weblog                  |
// +---------------------------------------------------------------------------+
// | config.php                                                                |
// | This file provides configuration for the linkreferer plugin for Geeklog   |
// | Please read the comments carefuly before editing anything.                |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2003 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Michael Jervis - Mike@fuckingbrit.com                                     |
// |                                                                           |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    tomw@pigstye.net                         |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
// $Log: config.php,v $
// Revision 1.2  2003/09/30 16:19:50  themike
// Release 1.0
//
define ('LR_VERSION', '0.1');


global $_TABLES, $_DB_table_prefix;

/* Insert an entry into the $_TABLES array for the relevant Database table */
$_TABLES['reflinks']       = $_DB_table_prefix . 'reflinks';

/* Configure the number of COLUMNS of buttons to display in the user side site*/
$_CONF['linkreferer_table_cols'] = 5;
/* Display text link block on the user side site, You might want to turn this
 * off if you want button links only.
 */
$_CONF['linkreferer_text_links'] = true;
/* This defines the width and height to force the buttons too. I use 88x31,
 * but there are other standard sizes you might want to force too.
 */
$_CONF['linkreferer_imagewidth'] = 88;
$_CONF['linkreferer_imageheight'] = 31;
/* This is a POSIX compatible regular expression. This is used to define the
 * format of a button image file. In my case it's button<anything>.gif you
 * may like to change this for some bizarre reason of your own, so it's an
 * option
 */
$_CONF['linkreferer_bexp'] = '^button.*\.gif$';

/* This configures the options for the phpblock function. You can add as many
 * items to the array as you like. This is an array of arrays. Each array has
 * one element. That element has a name which is selected from a list of options
 * and points at a value. The type of the value depends on the option selected
 * for the name. Here are the details:
 *
 * Name:        Value Details:                  What it does:
 * topin        set to a number                 Displays the top n refering
 *              (eg array( "topin" => 1 ))      links
 * topout       set to a number                 Displays the top n visited links
 * random       set to a number                 Displays n random links
 * fixed        Set to alist of numbers         Displays a specific list of links
 *              (eg array( "fixed" => "1,2,3"
 *
 * random blocks will not display items specified in fixed/topin/topout blocks.
 * However, if you specify top refering site and top visited site, and it is
 * the same site, it will be displayed twice, as this is statisticaly correct.
 *
 * Basicly, topin/topout/fixed blocks are generated, then random blocks are
 * generated, then it's rendered in the order specified. Yay. Fun.
 *
 * If you ask me, there is no point in multiple topin/topout blocks. Since the
 * counter wont' resume. You can't have top 2 then a random then top 3/4th links.
 * Example:
 *        $linkreferer_phpblock = array(
 *                           array( "topin" => 1),
 *                           array( "topout" => 1),
 *                           array( "random" => 3),
 *                           array( "fixed" => "1,2,3" )
 *                       );
 */
$linkreferer_phpblock = array( array( "fixed" => "1" ) );
$_CONF['linkreferer_block_settings'] = $linkreferer_phpblock;

/* This defines if the phpblock should start new blocks for each of the sections
 * specified. i.e. if you set this to true and have a topin and a topout specified
 * you will appear to have two blocks in your side bar, not just one.
 */
$_CONF['linkreferer_block_multi'] = true;

?>