<?php
//
// +---------------------------------------------------------------------------+
// | linkreferer Plugin 1.0 for Geeklog - The Ultimate Weblog                  |
// +---------------------------------------------------------------------------+
// | functions.inc                                                             |
// | This file does two things: 1) it implements the necessary Geeklog Plugin  |
// | API method and 2) implements all the common code needed by the linkreferer|
// | PHP files.                                                                |
// |                                                                           |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2003 by the following authors:                              |
// |                                                                           |
// | Author:                                                                   |
// | Michael Jervis - Mike@fuckingbrit.com                                     |
// |                                                                           |
// | Constructed with the Universal Plugin                                     |
// | Copyright (C) 2002 by the following authors:                              |
// | Tom Willett                 -    tomw@pigstye.net                         |
// | Blaine Lang                 -    langmail@sympatico.ca                    |
// | The Universal Plugin is based on prior work by:                           |
// | Tony Bibbs                  -    tony@tonybibbs.com                       |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
// $Log: functions.inc,v $
// Revision 1.4  2003/10/01 07:34:18  themike
// Release 1.1a: Fixed basic image display, again
//
// Revision 1.3  2003/09/30 16:54:55  themike
// Release 1.1: Fixed basic image display
//
// Revision 1.2  2003/09/30 16:19:50  themike
// Release 1.0
//

/**
* Language file Include
*/
$langfile = $_CONF['path'] . 'plugins/linkreferer/language/' . $_CONF['language'] . '.php';

if (file_exists ($langfile))
{
    include_once ($langfile);
}
else
{
    include_once ($_CONF['path'] . 'plugins/linkreferer/language/english.php');
}

/*
* Include {plugin} config file
*/
require_once ($_CONF['path'] . 'plugins/linkreferer/config.php');

// +---------------------------------------------------------------------------+
// | Geeklog Plugin API Implementations                                        |
// +---------------------------------------------------------------------------+

/**
* Returns the items for this plugin that should appear on the main menu
*
* NOTE: this MUST return the url/value pairs in the following format
* $<arrayname>[<label>] = <url>
*
*
* @return    array   Associative array of menu items to be added to menu
*
*/
function plugin_getmenuitems_linkreferer()
{
    global $_CONF, $LANG_LINKREFERER;

    $menulabel = $LANG_LINKREFERER['linkreferer'];  // Put your menu label here
    $menurul = $_CONF['site_url'] . "/linkreferer/index.php";     // Menu url here

    $menuitems = array();
    $menuitems["$menulabel"] = $menurul;
    return $menuitems;

}

/**
* Check to see if this Plugin uses comments
*
* Geeklog is checking to see if this plugin supports comments, tell it no!
* NOTE: to support comments you must use the same date/time based ID for your
* widget.  In other words, to make primary keys for your plugin you should call
* makesid().  Comments are keyed off of that...it is a limitation on how geeklog
* does comments.
*
* @return   boolean true or false
*
*/
function plugin_commentsupport_linkreferer()
{
    return false;
}

/**
* Shows the statistics for the plugin on stats.php.  If
* $showsitestats is 1 then we are to only print the overall stats in the 'site
* statistics' box otherwise we show the detailed stats for the plugin
*
* Universal Plugin:  Modify/uncomment use it
*
* @param    int showsitestate   Flag to let us know which stats to get
* @return   string  returns formatted HTML to insert in stats page
*
*/
function plugin_showstats_linkreferer($showsitestats)
{
    global $_CONF, $_TABLES,$LANG_LINKREFERER;

    $stat_templates = new Template($_CONF['path_layout'] . 'stats');
    $stat_templates->set_file(array('itemstats'=>'itemstatistics.thtml',
                            'statrow'=>'singlestat.thtml'));
        $retval='';
    if ($showsitestats == 1) {
        // This shows in the summary box
        $total_pages=DB_count($_TABLES['reflinks'],'status','1');     // Fill this with count for summary
        $summary_label = $LANG_LINKREFERER['linkreferer'];                   // Fill this with label displayed

        $retval = "<table border = '0' width='100%' cellspacing='0' cellpadding='0'>";
        $retval .= "<tr><td>$summary_label</td>";
        $retval .= "<td align='right'>" . $total_pages . "&nbsp;&nbsp </td></tr></table>";
    } else {
        // This fills the top the box  Use the following as a template
        $result = DB_query("SELECT id, title, hitsout from {$_TABLES['reflinks']} WHERE status=1 AND hitsout > 0 ORDER BY hitsout desc LIMIT 10");
        $nrows  = DB_numRows($result);
        $retval .= COM_startBlock($LANG_LINKREFERER['top_10_links_out']);
        if ($nrows > 0) {
            $stat_templates->set_var('item_label',$LANG_LINKREFERER['url']);
            $stat_templates->set_var('stat_name',$LANG_LINKREFERER['hits']);
            for ($i = 0; $i < $nrows; $i++) {
                $A = DB_fetchArray($result);
                $stat_templates->set_var('item_url', $_CONF['site_url'] . '/linkreferer/index.php?op=out&id=' . $A['id']);
                $stat_templates->set_var('item_text', $A['title']);
                $stat_templates->set_var('item_stat', $A['hitsout']);
                $stat_templates->parse('stat_row','statrow',true);
            }
            $stat_templates->parse('output','itemstats');
            $retval .= $stat_templates->finish($stat_templates->get_var('output'));
        } else {
            $retval .= $LANG_LINKREFERER['no_out_links'];
        }
        $retval .= COM_endBlock();
        $stat_templates = new Template($_CONF['path_layout'] . 'stats');
    $stat_templates->set_file(array('itemstats'=>'itemstatistics.thtml',
                            'statrow'=>'singlestat.thtml'));
        $result = DB_query("SELECT id, title, hitsin from {$_TABLES['reflinks']} WHERE status=1 AND hitsin > 0 ORDER BY hitsin desc LIMIT 10");
        $nrows  = DB_numRows($result);
        $retval .= COM_startBlock($LANG_LINKREFERER['top_10_links_in']);
        if ($nrows > 0) {
            $stat_templates->set_var('item_label',$LANG_LINKREFERER['url']);
            $stat_templates->set_var('stat_name',$LANG_LINKREFERER['hits']);
            for ($i = 0; $i < $nrows; $i++) {
                $A = DB_fetchArray($result);
                $stat_templates->set_var('item_url', $_CONF['site_url'] . '/linkreferer/index.php?op=out&id=' . $A['id']);
                $stat_templates->set_var('item_text', $A['title']);
                $stat_templates->set_var('item_stat', $A['hitsin']);
                $stat_templates->parse('stat_row','statrow',true);
            }
            $stat_templates->parse('output','itemstats');
            $retval .= $stat_templates->finish($stat_templates->get_var('output'));
        } else {
            $retval .= $LANG_LINKREFERER['no_in_links'];
        }
        $retval .= COM_endBlock();
    }
    return $retval;
}

/**
* This will put an option for the plugin in the command and control block on moderation.php
*
* Add the plugin name, icon and link to the command and control block in moderation.php
*
* @return   array   Array containing (plugin name, admin url, url of plugin icon)
*
*/
function plugin_cclabel_linkreferer()
{
    global $_CONF,$LANG_LINKREFERER;

    return array($LANG_LINKREFERER['linkreferer'],$_CONF['site_admin_url'] . '/plugins/linkreferer/index.php',$_CONF['site_url'] . '/linkreferer/images/linkreferer.gif');
}

/**
* Returns the administrative option for this plugin
*
* Adds the plugin to the Admin menu
*
* Universal Plugin:  Modify/Uncomment use it
*
* @return   array   Array containing (plugin name, plugin admin url, # of items in plugin or '')
*
*/
function plugin_getadminoption_linkreferer()
{
    global $_CONF, $_TABLES, $LANG_LINKREFERER;

    if (SEC_hasRights('linkreferer.admin')) {
        return array($LANG_LINKREFERER['linkreferer'], $_CONF['site_admin_url'] . '/plugins/linkreferer/index.php', DB_count($_TABLES['reflinks']));
    }
}

/**
* Removes the datastructures for this plugin from the Geeklog database.
* This routine will get called from the Plugin install program if user select De-Install or if Delete is used in the Plugin Editor.
* The Plugin Installer will also call this routine upon and install error to remove anything it has created.
* The Plugin installer will pass the optional parameter which will then double check that plugin has first been disabled.
*
* Returns True if all Plugin related data is removed without error
*
* @param    string   $installCheck     Defult is blank but if set, check if plugin is disabled first
* @return   boolean True if successful false otherwise
*
*/
function plugin_uninstall_linkreferer($installCheck='')
{
    global $_TABLES, $LANG_LINKREFERER;

    // The {plugin}s need to be changed to the name of your plugin
    // Enter the names of your plugin table names for table1 ...
    $pi_name='linkreferer';
    $FEATURES = array ( 'linkreferer.admin', 'linkreferer.submit');
    $TABLES = array ('reflinks');

    // Check and see if plugin is still enabled - if so display warning and exit
    if ($installCheck != '' && DB_getItem($_TABLES['plugins'],'pi_enabled', 'pi_name = "' .$pi_name. '"')) {
        COM_errorLog("Plugin is installed and enabled. Disable first if you want to de-install it",1);
        $display .= COM_startBlock($LANG_LINKREFERER['warning']);
        $display .= $LANG_LINKREFERER['enabled'];
        $display .= COM_endBlock();
        echo $display;
        return false;
        exit;
    }

    // Ok to proceed and delete plugin - Unregister the plugin with Geeklog
    COM_errorLog('Attempting to unregister the linkreferer plugin from Geeklog',1);
    DB_query("DELETE FROM {$_TABLES['plugins']} WHERE pi_name = '$pi_name'",1);

    // Drop linkreferer tables
    foreach($TABLES as $table) {
        $t = $_TABLES["$table"];
        COM_errorLog("Removing Table $t",1);
        DB_query("DROP TABLE $t",1);
    }

    // Remove Security for this plugin
    $grp_id = DB_getItem($_TABLES['vars'], 'value', "name = '{$pi_name}_gid'");

    COM_errorLog("Removing $pi_name Admin Group", 1);
    DB_query("DELETE FROM {$_TABLES['groups']} WHERE grp_id = $grp_id",1);
    DB_query("DELETE FROM {$_TABLES['vars']} WHERE name = '{$pi_name}_gid'");
    COM_errorLog("Removing root users from admin of $pi_name");
    DB_query("DELETE FROM {$_TABLES['group_assignments']} WHERE ug_main_grp_id = $grp_id",1);

    // Remove all the associated features -- access rights
    foreach ($FEATURES as $feature) {
        COM_errorLog("Removing $feature feature and rights to it",1);
        $feat_id = DB_getItem($_TABLES['features'], 'ft_id', "ft_name = '$feature'");
        DB_query("DELETE FROM {$_TABLES['access']} WHERE acc_ft_id = $feat_id",1);
        DB_query("DELETE FROM {$_TABLES['features']} WHERE ft_id = $feat_id",1);
    }

    COM_errorLog('...success',1);
    return true;
}

/**
* Returns the number of submissions waiting moderation
*
* Calculates the number of submissions that are currently waiting
* to be moderated and returns that number.
*
* @return      int       number of submissions awaiting moderation
*/
function plugin_submissioncount_linkreferer() {
    global $_TABLES;
    return DB_count($_TABLES['reflinks'],'status','0');
}

/**
 * Generates the page, including button and text links.
 *
 * @return  string  html to display
 */
function linkreferer_displayLinks()
{
    global $LANG_LINKREFERER, $_CONF;
    $display .= COM_siteHeader();
    $display .= COM_startBlock($LANG_LINKREFERER['linkreferer']);
    $display .= "<center><a href=\"{$_CONF['site_url']}/linkreferer/index.php";
    $display .= "?op=submit\">Add Your Site</a></center><br>\n";
    $display .= linkreferer_buttonLinks();
    $display .= COM_endBlock();

    /* The user may have disabled gay text links for gay users */
    if( $_CONF['linkreferer_text_links'] )
    {
        $display .= COM_startBlock( $LANG_LINKREFERER['textlinks'] );
        $display .= linkreferer_textLinks();
        $display .= COM_endBlock();
    }

    $display .= COM_siteFooter();
    return $display;
}


/**
 * generates a list of link buttons. The main point of the plugin.
 *
 * @return string html to display.
 */
function linkreferer_buttonLinks()
{
    global $_TABLES, $_USER, $_GROUPS, $_CONF, $LANG_LINKREFERER;
  //    $linklist = new Template($_CONF['path_layout'] . 'links');
//    $linklist->set_file(array('linklist'=>'links.thtml','catlinks'=>'categorylinks.thtml','link'=>'linkdetails.thtml','catnav'=>'categorynavigation.thtml','catrow'=>'categoryrow.thtml','catcol'=>'categorycol.thtml','actcol'=>'categoryactivecol.thtml','pagenav'=>'pagenavigation.thtml'));

    if( empty( $_USER['uid'] ) )
    {
        $user = 0;
    } else {
        $user = $_USER['uid'];
    }
    $permsql = COM_getPermSQL( "AND", $user );

    $sql = "SELECT id,title,image FROM {$_TABLES['reflinks']} WHERE ";
    $sql .= "status=1 AND image != '' AND image != '0' ";
    $sql .= "{$permsql} ";
    $sql .= "ORDER BY hitsin DESC,title ASC";
    $result = DB_query($sql);
    $nrows = DB_numRows($result);
    if ($nrows == 0) {
        $display .= $LANG_LINKREFERER['no_links'];
    } else {
        $display .= "<table>\n<tr>\n";
        for ($i = 0; $i < $nrows; $i++) {
            $A = DB_fetchArray($result);
            $A['title'] = stripslashes( $A['title'] );
            $display .= '<td>';
            $display .= "<a href=\"{$_CONF['site_url']}/linkreferer/index.php"
                     ."?op=out&id={$A['id']}\" target=\"_blank\"><img src=\""
                     .$A['image']."\" alt=\"{$A['title']}\" border=\"0\""
                     ." height=\"{$_CONF['linkreferer_imageheight']}\" "
                     ." width=\"{$_CONF['linkreferer_imagewidth']}\"></a>";
            $display .= '</td>';
            if( ( ( $i % $_CONF['linkreferer_table_cols'] ) == 4 ) )
            {
              $display .= "\n</tr>\n<tr>\n";
            }
        }
        $display .= "</table>";
    }
    return $display;
}

/**
 * generates a list of text links. The sucky part that other users might want.
 *
 * @return string html to display.
 */
function linkreferer_textLinks()
{
    global $_TABLES, $_USER, $_GROUPS, $_CONF, $LANG_LINKREFERER;
  //    $linklist = new Template($_CONF['path_layout'] . 'links');
//    $linklist->set_file(array('linklist'=>'links.thtml','catlinks'=>'categorylinks.thtml','link'=>'linkdetails.thtml','catnav'=>'categorynavigation.thtml','catrow'=>'categoryrow.thtml','catcol'=>'categorycol.thtml','actcol'=>'categoryactivecol.thtml','pagenav'=>'pagenavigation.thtml'));

    if( empty( $_USER['uid'] ) )
    {
        $user = 0;
    } else {
        $user = $_USER['uid'];
    }
    $permsql = COM_getPermSQL( "AND", $user );

    $sql = "SELECT id,title FROM {$_TABLES['reflinks']} WHERE ";
    $sql .= "status=1 AND (image = '' OR image = '0') ";
    $sql .= "{$permsql} ";
    $sql .= " ORDER BY hitsin DESC,title ASC";
    $result = DB_query($sql);
    $nrows = DB_numRows($result);
    if ($nrows == 0) {
        $display .= $LANG_LINKREFERER['no_links'];
    } else {
        for ($i = 0; $i < $nrows; $i++) {
            $A = DB_fetchArray($result);
            $A['title'] = stripslashes( $A['title'] );
            $display .= "<a href=\"{$_CONF['site_url']}/linkreferer/index.php"
                     ."?op=out&id={$A['id']}\" target=\"_blank\">{$A['title']}</a>";
            $display .= "<br>\n";
        }
    }
    return $display;
}

/**
 * Visit a url, logging an outgoing hit.
 * @param id unique key of the site to visit
 */
function linkreferer_visit( $id )
{
    global $_CONF, $_TABLES, $LANG_LINKREFERER;
    $int_id = (int) $id;
    if( $int_id == $id )
    {
        $sql = "UPDATE {$_TABLES['reflinks']} SET hitsout = hitsout + 1 WHERE id='$id' AND status=1";
        DB_Query( $sql );
        $sql = "SELECT url FROM {$_TABLES['reflinks']} WHERE id='$id' AND status=1";
        $result = DB_Query( $sql );
        $nrows = DB_numRows( $result );
        if( $nrows == 0 )
        {
            return linkreferer_displayLinks();
        } else {
            $display = COM_siteHeader();
            $display .= COM_startBlock( $LANG_LINKREFERER['redirecting'] );
            $A = DB_fetchArray( $result );
            $display .= $LANG_LINKREFERER['your_browser_redirect'];
            $display .= "<br><center><a href=\"{$A['url']}\">{$LANG_LINKREFERER['if_not_click_here']}</a></center>";
            $display .= COM_endBlock();
            $display .= "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"3;URL={$A['url']}\">";
            $display .= COM_siteFooter();
            return $display;
        }
    } else {
        return linkreferer_displayLinks();
    }
}

/**
 * If we have a hit from a url we are tracking, add one to it's score.
 * @param id The id of the link to record a hit for
 */
function linkreferer_hitin( $id )
{
    global $_TABLES;
    if( is_numeric( $id ) )
    {
        $sql = "UPDATE {$_TABLES['reflinks']} SET hitsin = hitsin + 1 WHERE id='$id' AND status=1";
        DB_Query( $sql );
    }
}

/**
 * Generates the form for users to submit links to.
 * @return HTML to display.
 */
function linkreferer_submitform($reason = '', $url='', $title='', $info='', $image='')
{
    global $_CONF, $LANG_LINKREFERER;

    $display = COM_siteHeader();
    $display .= COM_startBlock( $LANG_LINKREFERER['submit_link'] );
    $display .= "<form action=\"{$_CONF['site_url']}/linkreferer/index.php\"";
    $display .= " method=\"Post\" name=\"linkreferer\">\n<table>";
    $display .= "<input type=\"hidden\" name=\"op\" value=\"submitprocess\">\n";
    $display .= "<tr><td colspan=\"2\">{$LANG_LINKREFERER['submitinstructions']}</td></tr>\n";
    if( $reason != '' )
    {
        $display .= "<tr><td colspan=\"2\"><b>$reason</b></td></tr>\n";
    }
    $display .= linkreferer_basicForm($url, $title, $info, $image);
    $display .= "<tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" ";
    $display .= "name=\"submit\" value=\"{$LANG_LINKREFERER['submit']}\">\n";
    $display .= "</table></form>\n";
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    return $display;
}

function linkreferer_confirmSubmit()
{
    global $_CONF, $LANG_LINKREFERER, $_REQUEST, $_TABLES;
    $url = $_REQUEST['url'];
    $title = $_REQUEST['title'];
    $info = $_REQUEST['info'];
    $image = $_REQUEST['image'];
    if( $url == '' || $title == '' )
    {
        $reason = $LANG_LINKREFERER['one_or_more_missing'];
        return linkreferer_submitform( $reason, $url, $title, $info, $image );
    } else {
        $display = COM_siteHeader();
        $display .= COM_startBlock( $LANG_LINKREFERER['confirm_please'] );
        $display .= $LANG_LINKREFERER['confirm_please_text'].'<br><br><center>';
        if( $image != '' )
        {
            $display .= "<a href=\"{$url}\" target=\"_blank\">"
                      ."<img src=\"{$image}\" border=\"0\" alt=\"{$title}\""
                      ." width=\"{$_CONF['linkreferer_imagewidth']}\""
                      ." height=\"{$_CONF['linkreferer_imageheight']}\"></a><br>\n";
        } else {
            $display .= "<a href=\"{$url}\" target=\"_blank\">{$title}</a><br>\n";
        }
        $click = "document.forms.linkreferer.op.value='submitprocess';document.forms.linkreferer.submit();";
        $display .= '</center><br><br>'.COM_endBlock();
        $display .= COM_startBlock( $LANG_LINKREFERER['submit_link'] );
        $display .= "<form action=\"{$_CONF['site_url']}/linkreferer/index.php\"";
        $display .= " method=\"Post\" name=\"linkreferer\">\n<table>";
        $display .= "<input type=\"hidden\" name=\"op\" value=\"submitconfirmed\">\n";
        $display .= "<tr><td colspan=\"2\">{$LANG_LINKREFERER['submitinstructions']}</td></tr>\n";
        $display .= linkreferer_basicForm( $url, $title, $info, $image );
        $display .= "<tr><td colspan=\"2\" align=\"right\"><input type=\"button";
        $display .= "\" name=\"back\" value=\"{$LANG_LINKREFERER['upd_button']}";
        $display .= "\" onclick=\"$click\">&nbsp;<input type=\"submit\" ";
        $display .= "name=\"submitb\" value=\"{$LANG_LINKREFERER['submit']}\">\n";
        $display .= "</table></form>\n";
        $display .= COM_endBlock();
        $display .= COM_siteFooter();
        return $display;
    }
}

/**
 * Generates the core part of the form, as used by both admin and submit
 * @param url the url to prepopulate with
 * @param title the title of the site
 * @param info site blurb
 * @param image url for the button image
 */
function linkreferer_basicForm( $url='http://', $title='', $info='', $image='' )
{
    global $LANG_LINKREFERER;
    $display = "<tr><td>".$LANG_LINKREFERER['site_url']."</td><td><input "
             ."type=\"text\" name=\"url\" value=\"$url\">*</td></tr>\n";
    $display .= "<tr><td>".$LANG_LINKREFERER['site_title']."</td><td><input "
             ."type=\"text\" name=\"title\" value=\"$title\">*</td></tr>\n";
    $display .= "<tr><td>".$LANG_LINKREFERER['site_info']."</td><td><input "
             ."type=\"text\" name=\"info\" value=\"$info\"></td></tr>\n";
    $display .= "<tr><td>".$LANG_LINKREFERER['site_image']."</td><td><input "
             ."type=\"text\" name=\"image\" value=\"$image\"></td></tr>\n";
    return $display;
}

/**
 * commits a link to the database.
 */
function linkreferer_submit()
{
    global $_TABLES,$_CONF,$_REQUEST,$LANG_LINKREFERER;
    $title = addslashes( strip_tags( COM_checkWords( $_REQUEST['title'] ) ) );
    $title = "'$title'";
    $url = strip_tags( $_REQUEST['url'] );
    $url = "'$url'";
    $info = addslashes( htmlspecialchars( COM_checkWords( $_REQUEST['info'] ) ) );
    $image = strip_tags( $_REQUEST['image'] );
    if (empty ($_USER['username'])) { // anonymous user
        $owner_id = 1;
    } else {
        $owner_id = $_USER['uid'];
    }
    $group_id = DB_getItem($_TABLES['groups'],'grp_id',"grp_name = 'linkreferer Admin'");


    $sql = "INSERT INTO {$_TABLES['reflinks']} (title,url,owner_id,Group_id";
    if( $image != '' )
    {
        $image = "'$image'";
        $sql .= ", image";
        $values .= ", $image";
    }
    if( $info != '' )
    {
        $info = "'$info'";
        $sql .= ", info";
        $values .= ", $info";
    }

    $sql .= ") VALUES ($title,$url,$owner_id,$group_id $values)";
    DB_Query( $sql );
    $id = DB_insertId();
    $display = COM_siteHeader();
    $display .= COM_showMessage(15);
    $display .= COM_startBlock( $LANG_LINKREFERER['submitted'] );
    $display .= $LANG_LINKREFERER['submitted_text']."<br><br>\n";
    $display .= linkreferer_getLinkBacks( $id );
    $display .= COM_endBlock();
    $display .= COM_siteFooter();
    return $display;
}

/**

 * @param id the id for the link back
 * @return HTML to render
 */
function linkreferer_getLinkBacks( $id )
{
    global $_CONF;
    $buttons = linkreferer_getButtons();
    $count = 0;
    $display = "<table>";
    while( list( , $button ) = each( $buttons ) )
    {
        if( $count == 0 )
        {
            $display .= "<tr>\n";
        }
        $display .= linkreferer_formatLinkBack( $button, $id );
        if( $count == $_CONF['linkreferer_table_cols'] )
        {
            $display .= "</tr>\n";
            $count = 0;
        } else {
            $count++;
        }
    }
    $display .= "</table>";
    return $display;
}

/**
 * Formats a link into a 'chose me' block
 * @param button the image url
 * @param id the id of the link back
 * @returns HTML formated to display.
 */
function linkreferer_formatLinkBack( $button, $id )
{
    global $_CONF;
    $link = "<a href=\"{$_CONF['site_url']}?linkreferer=$id\" target=\"_blank\">"
          ."<img src=\"$button\" alt=\"{$_CONF['site_name']}\" border=\"0\"></a>";
    $display = "<td align=\"center\">$link<br><textarea cols=\"10\" rows=\"3\">"
             ."$link</textarea></td>\n";
    return $display;
}

/**
 * Gets all possible return link items for the user. Will look for
 * /linkreferer/images/buttons/button*.gif and
 * /layoutdir/<layout>/images/linkreferer/buttons/button*.gif
 * @return array of buttons
 */
function linkreferer_getButtons()
{
    global $_CONF;
    $buttons = array();
    $paths = array();
    $paths[] = "{$_CONF['path_html']}linkreferer/images/buttons/";

    if( is_dir( "{$_CONF['path_html']}layout/" ) )
    {
        if( $handle = opendir( "{$_CONF['path_html']}layout/" ) )
        {
            while( $file = readdir( $handle ) )
            {
                if( @is_dir( "{$_CONF['path_html']}layout/$file/images/buttons" ) )
                {
                    $paths[] = "{$_CONF['path_html']}layout/$file/images/buttons";
                }
            }
        }
    }

    while( list( , $path) = each( $paths ) )
    {
        if( is_dir( $path ) )
        {
            if( $handle = opendir( $path ) )
            {
                while( $file = readdir( $handle ) )
                {
                    if( linkreferer_isButton( $file ) )
                    {
                        $buttons[] = str_replace(
                                        $_CONF['path_html'],
                                        $_CONF['site_url'].'/',
                                        $path).'/'.$file;
                    }
                }
           }
       }
    }

    return $buttons;
}

/**
 * takes a file name and returns true if it is of the form button*.gif
 * you can over-ride the regular expression in config for the plugin
 * @param filename the filename to check
 * @return boolean true if and only if button*.gif is a good match.
 */
function linkreferer_isButton( $filename )
{
    global $_CONF;
    return eregi( $_CONF['linkreferer_bexp'], $filename );
}

/**
 * List all un-approved, then all approved links for the admin interface
 * @return HTML to display.
 */
function linkreferer_admin_list()
{
    global $_TABLES, $_CONF, $LANG_LINKREFERER;
    $sql = "SELECT id, title, url, image, info FROM "
         .$_TABLES['reflinks']." WHERE status=0 ORDER BY title DESC";
    $result = DB_Query( $sql );
    $nrows = DB_numRows( $result );
    if( $nrows > 0 )
    {
        $display .= COM_startBlock( $LANG_LINKREFERER['admin_submitted'] );
        $display .= "<table><tr><td>Site</td><td>Image</td><td>Info</td><td>Options</td></tr>\n";
        for ($i = 0; $i < $nrows; $i++) {
            $A = DB_fetchArray($result);
            $A['title'] = stripslashes( $A['title'] );
            $display .= "<tr><td><a href=\"{$A['url']}\">{$A['title']}</a></td>";
            if( $A['image'] != '' and $A['image'] != '0' )
            {
                $display .= "<td><img src=\"{$A['image']}\"></td>";
            } else {
                $display .= "<td>&nbsp;</td>";
            }
            $display .= "<td>{$A['info']}</td><td><a href=\"{$_CONF['site_admin_url']}"
                     ."/plugins/linkreferer/index.php?op=delete&id="
                     ."{$A['id']}\">Delete</a> - <a href=\"{$_CONF['site_admin_url']}"
                     ."/plugins/linkreferer/index.php?op=edit&id={$A['id']}\">"
                     ."Edit</a> - <a href=\"{$_CONF['site_admin_url']}/plugins/"
                     ."linkreferer/index.php?op=togglestatus&id={$A['id']}\">"
                     ."Approve</a></td></tr>\n";
        }
        $display .= "</table>\n";
        $display .= COM_endBlock();
    }
    $sql = "SELECT id, title, url, image, info FROM "
         .$_TABLES['reflinks']." WHERE status=1 ORDER BY title DESC";
    $result = DB_Query( $sql );
    $nrows = DB_numRows( $result );
    if( $nrows > 0 )
    {
        $display .= COM_startBlock( $LANG_LINKREFERER['admin_live'] );
        $display .= "<table><tr><td>Site</td><td>Image</td><td>Info</td><td>Options</td></tr>\n";
        for ($i = 0; $i < $nrows; $i++) {
            $A = DB_fetchArray($result);
            $A['title'] = stripslashes( $A['title'] );
            $display .= "<tr><td><a href=\"{$A['url']}\">{$A['title']}</a></td>";
            if( ($A['image'] != '') && ($A['image'] != '0') )
            {
                $display .= "<td><img src=\"{$A['image']}\"></td>";
            } else {
                $display .= "<td>&nbsp;</td>";
            }
            $display .= "<td>{$A['info']}</td><td><a href=\"{$_CONF['site_admin_url']}"
                     ."/plugins/linkreferer/index.php?op=delete&id="
                     ."{$A['id']}\">Delete</a> - <a href=\"{$_CONF['site_admin_url']}"
                     ."/plugins/linkreferer/index.php?op=edit&id={$A['id']}\">"
                     ."Edit</a> - <a href=\"{$_CONF['site_admin_url']}/plugins/"
                     ."linkreferer/index.php?op=togglestatus&id={$A['id']}\">"
                     ."Expire</a></td></tr>\n";
        }
        $display .= "</table>\n";
        $display .= COM_endBlock();
    }
    return $display;
}

/**
 * Prompt to confirm link delete:
 * @return HTML to display.
 */
function linkreferer_admin_deleteConfirm()
{
    global $_CONF, $_TABLES, $LANG_LINKREFERER, $_REQUEST;
    $sql = "SELECT title, url, image FROM {$_TABLES['reflinks']} WHERE id='"
         . "{$_REQUEST['id']}'";
    $result = DB_Query( $sql );
    $nRows = DB_numRows( $result );
    if( $nRows > 0 )
    {
        $display = COM_startBlock( $LANG_LINKREFERER['admin_sure_delete'] );
        $A = DB_fetchArray( $result );
        $display .= $LANG_LINKREFERER['admin_sure_delete_text']."<br><br><center>";
        if( $A['image'] != '' && $A['image'] != '0' )
        {
            $display .= "<a href=\"{$A['url']}\"><img src=\"{$A['image']}\"></a>";
        } else {
            $display .= "<a href=\"{$A['url']}\">{$A['title']}</a>";
        }
        $display .= "</center><br>";
        $display .= "<br><center><a href=\"{$_CONF['site_admin_url']}"
                 . "/plugins/linkreferer/index.php?op=deleteconfirm&id="
                 . "{$_REQUEST['id']}\">Yes</a> - <a href= \""
                 . "{$_CONF['site_admin_url']}/plugins/linkreferer/index.php\">"
                 . "No</a></center><br><br>";
        $display .= COM_endBlock();
        return $display;
    } else {
        return linkreferer_admin_list();
    }
}

/**
 * Perform link deletion
 */
function linkreferer_admin_delete()
{
    global $_CONF, $_TABLES, $LANG_LINKREFERER, $_REQUEST;
    $sql = "DELETE FROM {$_TABLES['reflinks']} WHERE id='{$_REQUEST['id']}'";
    DB_Query( $sql );
    $timestamp = strftime( $_CONF['daytime'] );
    $display .= COM_showMessage(16);
    $display .= linkreferer_admin_list();
    return $display;
}

/**
 * Does similar to COM_shoeMessage but with messages I choose. So there.
 * @param title the title for the box
 * @param message the body message
 * @return html to display.
 */
function linkreferer_messageBox( $title, $message )
{
    global $_CONF;
    $timestamp = strftime( $_CONF['daytime'] );
    $retval .= COM_startBlock( $title . ' - ' . $timestamp, '',
               COM_getBlockTemplate( '_msg_block', 'header' ))
            . '<img src="' . $_CONF['layout_url']
            . '/images/sysmessage.gif" border="0" align="top" alt="">'
            . $message . '<br><br>'
            . COM_endBlock( COM_getBlockTemplate( '_msg_block', 'footer' ));
    return $retval;
}

/**
 * Updates the status field of a link to 1 - status
 */
function linkreferer_admin_togglestatus()
{
    global $_CONF, $_TABLES, $LANG_LINKREFERER, $_REQUEST;
    $sql = "UPDATE {$_TABLES['reflinks']} SET status = 1 - status WHERE id='{$_REQUEST['id']}'";
    DB_Query( $sql );
    $display .= linkreferer_messageBox( $LANG_LINKREFERER['status_toggled'],
                                        $LANG_LINKREFERER['status_toggled_text']
                                      );
    $display .= linkreferer_admin_list();
    return $display;
}

/**
 * Displays the edit page for administrators. Much like that for users, but with
 * the permissions and owners stuff on it.
 * @return HTML to display.
 */
function linkreferer_admin_editlink()
{
    global $_CONF, $_TABLES, $LANG_LINKREFERER, $_REQUEST, $LANG_ACCESS;
    $display .= COM_startBlock( $LANG_LINKREFERER['admin_edit_link'] );

    $sql = "SELECT * FROM {$_TABLES['reflinks']} WHERE id='{$_REQUEST['id']}'";
    $result = DB_Query( $sql );
    $nrows = DB_numrows( $result );
    if( $nrows > 0 )
    {
        $A = DB_fetchArray( $result );
        $url = $A['url'];
        $title = stripslashes( $A['title'] );
        $info = stripslashes( $A['info'] );
        $image = $A['image'];
        $hitsin = $A['hitsin'];
        $hitsout = $A['hitsout'];
        $status = $A['status'];
        $owner_id = $A['owner_id'];
        $group_id = $A['group_id'];
        $perm_owner = $A['perm_owner'];
        $perm_group = $A['perm_group'];
        $perm_members = $A['perm_members'];
        $perm_anon = $A['perm_anon'];
        $access = SEC_hasAccess($owner_id,$group_id,$perm_owner,$perm_group,$perm_members,$perm_anon);
    }

    // Form start, hidden elements.
    $display .= "<form name=\"linkreferer\" action=\"{$_CONF['site_admin_url']}"
             . "/plugins/linkreferer/index.php\" method=\"post\">\n<input "
             . "type=\"hidden\" name=\"op\" value=\"editconfirm\">\n<input "
             . "type=\"hidden\" name=\"id\" value=\"{$_REQUEST['id']}\"><table "
             . "width=\"100%\">\n";
    // Basic common edit parts
    $display .= linkreferer_basicForm( $url, $title, $info, $image );
    $display .= "<tr><td>{$LANG_LINKREFERER['admin_status']}:</td><td>"
              . "<input type=\"checkbox\" value=\"1\" name=\"status\"";
    // Admin can take it on and offline
    if( $status == 1 )
    {
        $display .= " CHECKED";
    }
    $display .= "></td></tr>\n<tr><td>{$LANG_LINKREFERER['admin_hitsinout']}"
              . "</td><td>$hitsin/$hitsout</td></tr>\n";
    // Add the permissions stuff:
    $display .= "<tr><td colspan=\"2\"><hr><b>{$LANG_ACCESS[accessrights]}</b><br>\n";
    $display .= "<table><tr><td>{$LANG_ACCESS[owner]}:</td><td>"
    	     .  DB_getItem($_TABLES['users'],'username',"uid = $owner_id")
    	     .  "</td></tr><tr><td>{$LANG_ACCESS[group]}:</td><td>";
    if( $access == 3 )
    {
        $usergroups = SEC_getUserGroups();
    	$groupdd = '<select name="group_id">' . LB;
        for ($i = 0; $i < count($usergroups); $i++) {
            $groupdd .= '<option value="' . $usergroups[key($usergroups)] . '"';
            if ($group_id == $usergroups[key($usergroups)]) {
               $groupdd .= ' selected="selected"';
            }
            $groupdd.= '>' . key($usergroups) . '</option>' . LB;
            next($usergroups);
        }
        $groupdd .= '</select>' . LB;
	} else {
		// they can't set the group then
        $groupdd .= DB_getItem($_TABLES['groups'],'grp_name',"grp_id = $group_id");
		$groupdd .= '<input type="hidden" name="group_id" value="' . $group_id . '">';
	}
	$display .= $groupdd.'</td></tr></table><br>';
    $display .= '<b>'.$LANG_ACCESS[permissions].':</b><br>'.$LANG_ACCESS[permissionskey];
    $display .= SEC_getPermissionsHTML(
                  $perm_owner, $perm_group, $perm_members, $perm_anon
                                      );
    $display .= "</td></tr>\n";
    // Various buttons
    $display .= "<tr><td colspan=\"2\" align=\"left\"><input type=\"button\""
              . " name=\"cancel\" value=\"{$LANG_LINKREFERER['cancel']}\""
              . " onclick=\"history.go(-1);\">&nbsp;<input type=\"button\" name=\""
              . "delete\" value=\"{$LANG_LINKREFERER['delete']}\" onclick=\""
              . "window.location='{$_CONF['site_admin_url']}/plugins/linkreferer"
              . "/index.php?op=delete&id={$_REQUEST['id']}'\">&nbsp;<input type=\"submit\""
              . " name=\"submitb\" value=\"{$LANG_LINKREFERER['submit']}\""
              . "></td></tr>\n</table></form>";
    $display .= COM_endBlock();
    return $display;
}

/**
 * Saves an admin edit of a link
 * @return HTML to display.
 */
function linkreferer_admin_editsave()
{
    global $_CONF, $_TABLES, $LANG_LINKREFERER, $_REQUEST, $MESSAGE;

    // Get the fields from the post:
    $title = addslashes( strip_tags( COM_checkWords( $_REQUEST['title'] ) ) );
    $title = "title = '$title', ";
    $url = strip_tags( $_REQUEST['url'] );
    $url = "url ='$url', ";
    $info = addslashes( htmlspecialchars( COM_checkWords( $_REQUEST['info'] ) ) );
    if( $info != '' )
    {
        $info = "info = '$info', ";
    } else {
        $info = "info = null, ";
    }
    $image = strip_tags( $_REQUEST['image'] );
    if( $image != '' )
    {
        $image = "image = '$image', ";
    } else {
        $image = "image = null, ";
    }
    // and the permissions shit:
    if( $_REQUEST['status'] != '' )
    {
        $status = "status = 1, ";
    } else {
        $status = "status = 0, ";
    }
    $group_id = $_REQUEST['group_id'];
    // Convert array values to numeric permission values
    $perm_owner = $_REQUEST['perm_owner'];
    $perm_group = $_REQUEST['perm_group'];
    $perm_members = $_REQUEST['perm_members'];
    $perm_anon = $_REQUEST['perm_anon'];
    if (is_array($perm_owner) OR is_array($perm_group) OR is_array($perm_members) OR is_array($perm_anon)) {
        list($perm_owner,$perm_group,$perm_members,$perm_anon) = SEC_getPermissionValues($perm_owner,$perm_group,$perm_members,$perm_anon);
    }
    $perm_owner = "perm_owner = $perm_owner, ";
    $perm_group = "perm_group = $perm_group, ";
    $perm_members = "perm_members = $perm_members, ";
    $perm_anon = "perm_anon = $perm_anon ";

    // Check for permissions on the object:
    $result = DB_query ("SELECT owner_id,group_id,perm_owner,perm_group,perm_members,perm_anon FROM {$_TABLES['reflinks']} WHERE id = '{$_REQUEST['id']}'");
    $A = DB_fetchArray ($result);
    $access = SEC_hasAccess ($A['owner_id'], $A['group_id'],
                $A['perm_owner'], $A['perm_group'], $A['perm_members'],
                $A['perm_anon']);
    if (($access < 3) || !SEC_inGroup ($group_id))
    {
        $display .= COM_startBlock ($MESSAGE[30], '',
                            COM_getBlockTemplate ('_msg_block', 'header'));
        $display .= $MESSAGE[31];
        $display .= COM_endBlock (COM_getBlockTemplate ('_msg_block', 'footer'));
        COM_errorLog("User {$_USER['username']} tried to illegally submit or edit link $lid",1);
    } else {
        $group_id = "group_id = $group_id, ";
        $sql = "UPDATE {$_TABLES['reflinks']} SET $title $info $url $image $status"
             . " $group_id $owner_id $perm_owner $perm_group $perm_members $perm_anon"
             . " WHERE id = '{$_REQUEST['id']}'";#
        DB_Query( $sql );
        $display .= linkreferer_messageBox( $LANG_LINKREFERER['admin_link_saved'],
                                            $LANG_LINKREFERER['admin_link_saved_text']
                                          );
        $display .= linkreferer_admin_list();
    }
    return $display;
}

/**
 * This is a PHP-Block function. i.e. it is designed to render a block on the
 * left or right side of the site. It displays a user defined number of buttons
 * from various selections. i.e. top n referes top m visited and o random
 * buttons. It can simulate multiple blocks. Yay. These can be defined in user
 * defined order. Rockage. See /plugins/linkreferer/config.php for config.
 * @return HTML to display.
 */
function phpblock_linkreferer_buttons()
{
    global $_CONF, $LANG_LINKREFERER;

    // Cache visited places.
    $used = array();
    $blocks = array();
    $display = "<center>";
    /* Complicated. First generate any topin topout blocks, and log ids. */
    $i = 0;
    while( list( , $item ) = each( $_CONF['linkreferer_block_settings'] ) )
    {
        while( list( $name, $value ) = each( $item ) )
        {
            switch( $name )
            {
                case 'topin':
                    $blocks[$i] = linkreferer_topblock( 0, $value, $used );
                    break;
                case 'topout':
                    $blocks[$i] = linkreferer_topblock( 1, $value, $used );
                    break;
                case 'fixed':
                    $blocks[$i] = linkreferer_fixedblocks( $value, $used );
                    break;
                default:
                    break;
            }
        }
        $i++;
    }
    $i = 0;
    reset( $_CONF['linkreferer_block_settings'] );
    while( list( , $item ) = each( $_CONF['linkreferer_block_settings'] ) )
    {
        while( list( $name, $value ) = each( $item ) )
        {
            switch( $name )
            {
                case 'topin':
                    if( ( $i > 0 ) && $_CONF['linkreferer_block_multi'] )
                    {
                        $str = $LANG_LINKREFERER['topin_block'];
                        $display .= "</center>";
                        $display .= COM_endblock().COM_startBlock( $str );
                        $display .= "<center>";
                    }
                    $display .= $blocks[$i];
                    break;
                case 'topout':
                    if( ( $i > 0 ) && $_CONF['linkreferer_block_multi'] )
                    {
                        $str = $LANG_LINKREFERER['topout_block'];
                        $display .= "</center>";
                        $display .= COM_endblock().COM_startBlock( $str );
                        $display .= "<center>";
                    }
                    $display .= $blocks[$i];
                    break;
                case 'fixed' :
                    if( ( $i > 0 ) && $_CONF['linkreferer_block_multi'] )
                    {
                        $str = $LANG_LINKREFERER['fixed_block'];
                        $display .= "</center>";
                        $display .= COM_endblock().COM_startBlock( $str );
                        $display .= "<center>";
                    }
                    $display .= $blocks[$i];
                    break;
                case 'random':
                    if( ( $i > 0 ) && $_CONF['linkreferer_block_multi'] )
                    {
                        $str = $LANG_LINKREFERER['random_block'];
                        $display .= "</center>";
                        $display .= COM_endblock().COM_startBlock( $str );
                        $display .= "<center>";
                    }
                    $blocks[$i] = linkreferer_randomblocks( $value, $used );
                    $display .= $blocks[$i];
                    break;
            }
        }
        $i++;
    }
    return "</center>".$display;
}

/**
 * returns the top $count links by $type, if $type is 0 then it's hitsin other
 * wise it's hitsout.
 * @param type 0 for hitsin 1 for hitsout
 * @param count number to display
 * @param used array of links displayed
 * @return formatted HTML set of buttons.
 */
function linkreferer_topblock( $type = 0, $count, &$used )
{
    global $_TABLES, $_USER, $LANG_LINKREFERER, $_CONF;

    $sql = "SELECT id, image, title FROM {$_TABLES['reflinks']} WHERE status = 1 "
         . " AND image != '' AND image != '0' ";
    $sql .= COM_getPermSQL( "AND", $_USER['uid'] );
    if( $type = 0 )
    {
        $sql .= " ORDER BY hitsin DESC LIMIT 0, $count";
    } else {
        $sql .= " ORDER BY hitsout DESC LIMIT 0, $count";
    }
    $result = DB_Query( $sql );
    $nrows = DB_numrows( $result );
    if( $nrows == 0 )
    {
        $display = $LANG_LINKREFERER['no_links_inout' + $type];
    } else {
        for( $i = 0; $i < $nrows; $i++ )
        {
            $A = DB_fetchArray( $result );
            $used[ $A['id'] ] = $A['id'];
            $display .= "<a href=\"{$_CONF['site_url']}/linkreferer/index.php"
                     ."?op=out&id={$A['id']}\" target=\"_blank\"><img src=\""
                     .$A['image']."\" alt=\"{$A['title']}\" border=\"0\""
                     ." height=\"{$_CONF['linkreferer_imageheight']}\" "
                     ." width=\"{$_CONF['linkreferer_imagewidth']}\"></a><br>\n";

        }
    }
    return $display;
}

/**
 * Displays links whos id is specified in $items, adds them to $used
 * @param items unique id of links to display.
 * @param used array of links displayed
 * @return formatted HTML set of buttons.
 */
function linkreferer_fixedblocks( $items, &$used )
{
    global $_TABLES, $_USER, $LANG_LINKREFERER, $_CONF;

    $sql = "SELECT id, image, title FROM {$_TABLES['reflinks']} WHERE status = 1 "
         . " AND image != '' AND image != '0' AND id in ($items) ";
    $sql .= COM_getPermSQL( "AND" );
    $result = DB_Query( $sql );
    $nrows = DB_numrows( $result );
    if( $nrows == 0 )
    {
        $display = $LANG_LINKREFERER['no_linksinout'];
    } else {
        for( $i = 0; $i < $nrows; $i++ )
        {
            $A = DB_fetchArray( $result );
            $used[ $A['id'] ] = $A['id'];
            $display .= "<a href=\"{$_CONF['site_url']}/linkreferer/index.php"
                     ."?op=out&id={$A['id']}\" target=\"_blank\"><img src=\""
                     .$A['image']."\" alt=\"{$A['title']}\" border=\"0\""
                     ." height=\"{$_CONF['linkreferer_imageheight']}\" "
                     ." width=\"{$_CONF['linkreferer_imagewidth']}\"></a><br>\n";

        }
    }
    return $display;
}

/**
 * Gets a random selection of $count blocks that are NOT already listed in $used
 * @param count number of blocks to get
 * @param used array of used items
 * @return formatted HTML
 */
function linkreferer_randomblocks( $count, &$used )
{
   global $_CONF, $_TABLES, $LANG_LINKREFERER;

    $ids = '(';
    while( list( , $value ) = each( $used ) )
    {
        $ids .= $value.",";
    }
    $ids = substr( $ids, 0, strlen( $ids ) - 1 );
    $ids .= ')';
    $sql = "SELECT id, image, title FROM {$_TABLES['reflinks']} WHERE status = 1 "
         . " AND image != '' AND image != '0' AND id not in $ids ";
    $sql .= COM_getPermSQL( "AND" );
    $result = DB_Query( $sql );
    $nrows = DB_numrows( $result );
    if( $nrows == 0 )
    {
        $display = $LANG_LINKREFERER['no_links'];
    } else {
        $items = array();
        for( $i = 0; $i < $nrows; $i++ )
        {
            $A = DB_fetchArray( $result );
            $items[] = $A;
        }
        shuffle( $items );
        $i = 0;
        if( $count > count( $items ) )
        {
            $count = count( $items );
        }
        for( $i = 0; $i < $count; $i++ )
        {
            $item = $items[$i];
            $display .= "<a href=\"{$_CONF['site_url']}/linkreferer/index.php"
                     ."?op=out&id={$item['id']}\" target=\"_blank\"><img src=\""
                     .$item['image']."\" alt=\"{$item['title']}\" border=\"0\""
                     ." height=\"{$_CONF['linkreferer_imageheight']}\" "
                     ." width=\"{$_CONF['linkreferer_imagewidth']}\"></a><br>\n";
        }
    }
    return $display;
}

/******************************************************************************/
/* If the url has the linkreferer get variable on it, then we are going to    */
/* Log an incoming hit. This page is parsed every load, so we can handle this */
/* here without affecting any other code. Yay geeklog. Better than Nuke.      */
/******************************************************************************/

if( $_REQUEST['linkreferer'] != '' )
{
    linkreferer_hitin( $_REQUEST['linkreferer'] );
}

?>